package lib.eole.posh;
import lib.shape.MovieShape;
import lib.image.LoadImage;
import lib.shape.GradMovieShape;
import lib.eole.posh.PoshStyle;
import flash.display.MovieClip;
import flash.text.TextField;
import flash.utils.Timer;
import flash.events.TimerEvent;
import flash.external.ExternalInterface;

class PoshButton extends MovieClip{
    private var icon:String;
    public var url:String;
    private var libelle:String;
    private var style:PoshStyle;
    // Masque et anim
    public var masque:MovieShape;
    static var maxOpacity:Float=0.7;
    static var delta:Float=0.05;
    static var timerDelta:Int=6;
    private var progressTimer:Timer;
    private var disgressTimer:Timer;

    public function new(libelle:String, url:String, icon:String, style:PoshStyle){
        super();
        this.url = url;
        this.style = style;
        this.addBg();
        this.addTextField(libelle);
        if (icon != ""){
        this.addIcon(icon);
        }
        this.addMask();
        this.addMouseBehaviour();
        this.buttonMode = true;
    }
    private function parseCData(s:String){
        return s.split( "<![CDATA[" ).join( "" ).split( "]]>" ).join( "" );
    }
    // Le texte
    private function addTextField(libelle:String){
        var text:TextField=new TextField();
        text.defaultTextFormat = this.style.font;
        text.multiline = true;
        text.htmlText = this.parseCData(libelle);
        text.x = this.style.font.left;
        text.y = this.style.font.top;
        this.addChild(text);
    }
    // Rajoute les couches
    private function addBg(){
        var color:Int = this.style.startColor;
        this.addShape();
        this.style.pad(2, 0x666666);
        this.addShape();
        this.style.pad(1, 0xffffff);
        this.addShape();
        this.style.pad(1, color);
        this.addShape();
        this.addBShape();
        this.style.pad(-4);
    }
    // Les differents elements constituant le fond
    private function addShape(){
        var bg:MovieShape = new MovieShape();
        bg.draw(this.style.btnBgColor, this.style.w , this.style.h, 10);
        bg.x = this.style.x;
        bg.y = this.style.y;
        this.addChild(bg);
    }
    // Le degrade
    private function addBShape(){
        var bg:GradMovieShape = new GradMovieShape();
        bg.draw(this.style.startColor, this.style.w , this.style.h, 10 , this.style.stopColor, Math.PI/2);
        bg.x = this.style.x;
        bg.y = this.style.y;
        bg.alpha = this.style.alpha;
        this.addChild(bg);
    }
    // L'image
    private function addIcon(icon:String){
        var icon:LoadImage = new LoadImage(icon);
        icon.x = 20;
        icon.y = 10;
        this.addChild(icon);
    }
    // Le masque
    private function addMask(){
        this.masque = new MovieShape();
        this.masque.draw(this.style.overColor, this.style.w , this.style.h, 10);
        this.masque.alpha = 0.0;
//        this.masque.x = this.style.x;
//        this.masque.y = this.style.y;
        this.addChild(this.masque);
    }
    // La souris
    private function addMouseBehaviour(){
        this.addEventListener(flash.events.MouseEvent.MOUSE_OVER, this.alphaUp);
        this.addEventListener(flash.events.MouseEvent.MOUSE_OUT, this.alphaDown);
        this.addEventListener(flash.events.MouseEvent.MOUSE_DOWN, this.clique);
        this.addEventListener(flash.events.MouseEvent.MOUSE_UP, this.release);
        this.progressTimer = new Timer(timerDelta);
        this.progressTimer.addEventListener(TimerEvent.TIMER, increase);
        this.progressTimer.stop();
        this.disgressTimer = new Timer(timerDelta);
        this.disgressTimer.addEventListener(TimerEvent.TIMER, decrease);
        this.progressTimer.stop();
    }
    private function alphaUp(e:flash.events.Event){
        disgressTimer.stop();
        progressTimer.start();
    }
    private function alphaDown(e:flash.events.Event){
        progressTimer.stop();
        disgressTimer.start();
    }
    // Fonction d'accroissement de l'opacité
    private function increase(event:flash.events.TimerEvent){
        this.masque.alpha += delta;
        if (this.masque.alpha >= maxOpacity){
            this.masque.alpha = maxOpacity;
            progressTimer.stop();
        }
    }
    // Fonction de diminution de l'opacité
    private function decrease(event:flash.events.TimerEvent){
        this.masque.alpha -= delta;
        if (this.masque.alpha <= 0.0){
            this.masque.alpha = 0.0;
            disgressTimer.stop();
        }
    }
    private function clique(e:flash.events.MouseEvent){
        this.masque.alpha = 0.9;
    }
    private function release(e:flash.events.MouseEvent){
        this.masque.alpha = 0.0;
        ExternalInterface.call("setUrl", this.url);
        }
}
