package lib.eole.posh;
import lib.shape.MovieShape;
import lib.eole.posh.PoshButton;
import lib.eole.posh.PoshStyle;
import flash.display.MovieClip;
import flash.text.TextField;
import flash.text.TextFieldAutoSize;
import flash.text.TextFormat;
import flash.text.TextFormatAlign;
import flash.external.ExternalInterface;
import haxe.xml.Fast;

class PoshDesktop extends MovieClip
{
    private var xml:Fast;
    private var btnList:Array<PoshButton>;
    private var jsscript:String;
    private var style:PoshStyle;
    public function new(xmlStr:Xml):Void{
        super();
        this.xml = new haxe.xml.Fast(xmlStr.firstElement());
        this.btnList = new Array<PoshButton>();
        this.parseStyle();
        this.makeBtns();
        this.makeBg();
        this.render();
    }
    public function addBtn(xmlentry:Fast){
        var libelle = xmlentry.node.libelle.innerHTML;
        var url:String = StringTools.trim(xmlentry.node.url.innerData);
        var icon:String="";
        if (xmlentry.hasNode.icon){
             icon = StringTools.trim(xmlentry.node.icon.innerData);
             }
        var btn:PoshButton = new PoshButton(libelle, url, icon, this.style);
        this.btnList.push(btn);
    }
    public function parseStyle(){
        if (this.xml.hasNode.style){
            var style_xml = this.xml.node.style;
            this.style=new PoshStyle(style_xml);
        }else{
            var defstylexml = new Fast(Xml.parse('<style />').firstElement());
            this.style=new PoshStyle(defstylexml);
        }
    }
    public function makeBtns(){
        if (this.xml.hasNode.buttondatas){
            var buttons = this.xml.node.buttondatas;
            if (buttons.hasNode.buttondata){
                var buttondatas = buttons.nodes.buttondata;
                for (button_xml in buttondatas){
                    if ((button_xml.hasNode.url) && (button_xml.hasNode.libelle)){
                        this.style.init(); // on réinitialise certaines valeurs
                        this.addBtn(button_xml);
                    }
                }
            }
        }else{
            var txt = "# Une erreur est survenue à la récupération de votre profil. # \n";
            txt += "-- Veuillez contacter votre administrateur. --";
            this.errMessage(txt);
            //trace(" -- Erreur dans le xml fournit -- ");
            }
    }
    public function errMessage(message:String){
            ExternalInterface.call("window.alert", message);
            // Scene background
            var background:MovieShape = new MovieShape();
            background.draw(0xee8855, 600, 150, 0);
            // Message Background
            var bg:MovieShape = new MovieShape();
            bg.draw(0xfefefe, 580, 110, 10);
            bg.y = 10;
            bg.x = 10;
            // Text
            var txtBox = new TextField();

            var formattage = new TextFormat();
            formattage.size = 15;
            formattage.color = 0x000000;
            formattage.align = TextFormatAlign.CENTER;
            txtBox.defaultTextFormat = formattage;

            txtBox.autoSize = TextFieldAutoSize.LEFT;
            txtBox.htmlText += message;

            txtBox.selectable = true;
            txtBox.width = 600;
            txtBox.height = 150;
            txtBox.x = 90;
            txtBox.y = 30;

            // Adding to the scene
            this.addChild(background);
            this.addChild(bg);
            this.addChild(txtBox);
            ExternalInterface.call("setObjectSize", 150, 600);
    }
    public function makeBg(){
       var bg:MovieShape = new MovieShape();
       bg.draw(this.style.bgColor, this.style.w, this.getTotalHeight(), 0);
       this.addChild(bg);
    }
    public function render(){
        for(i in 0...this.btnList.length){
            var btn:PoshButton = btnList[i];
            var pos_y = (this.style.h + this.style.padding)*i;
            btn.y = pos_y;
            this.addChild(btn);
            ExternalInterface.call("setObjectSize", this.getTotalHeight(), this.style.w);
        }
    }
    public function getTotalHeight(){
        var height = (this.style.h + this.style.padding)* this.btnList.length;
        return height;
    }
}
