package lib.eole.posh;
import lib.eole.posh.PoshTextFormat;
import flash.text.TextFormatDisplay;
import haxe.xml.Fast;

class InitBtn implements Dynamic<Int>{
    public var x:Int;
    public var y:Int;
    public var w:Int;
    public var h:Int;
    public function new(){
        this.x = 0;
        this.y = 0;
    }
}
class PoshStyle{
    private var xml:Fast;
    // Le desktop
    public var bgColor:Int; // couleur de fond du Desktop
    public var padding:Int; // padding entre les boutons
    // Les boutons
    private var init_btn:InitBtn;
    public var w:Int; // largeur du bouton
    public var h:Int; // hauteur du bouton
    public var x:Int;
    public var y:Int;
    public var btnBgColor:Int;
    public var startColor:Int; // couleur debut degradé
    public var stopColor:Int; // couleur fin dégradé
    public var alpha:Float;
    public var overColor:Int;
    // La police
    public var font:PoshTextFormat;

    public function new(style_xml:Fast){
//        trace(" + Parsing des éléments de style du Bureau +");
        this.init_btn = new InitBtn();
        this.xml = style_xml;
        this.parseStyle();
//        this.trace_obj();
    }
    private function trace_obj(){
        trace("   background-color : " + this.bgColor);
        trace("   background-padding : " + this.padding);
        trace(" ");
        trace("   button-width : " + this.w);
        trace("   button-height : " + this.h);
        trace("   button-btnBgColor : " + this.btnBgColor);
        trace("   button-startColor : " + this.startColor);
        trace("   button-stopColor : " + this.stopColor);
        trace("   button-overColor : " + this.overColor);
        trace("   font-size : " + this.font);
    }
    private function parseStyle(){
        // parse les elements de style
//        trace("  + Parsing de la balise <background> +");
        if (this.xml.hasNode.background){
            this.parseBackground(this.xml.node.background);
        }
        else{
            var defbgxml = new Fast(Xml.parse('<background />').firstElement());
            this.parseBackground(defbgxml);
        }
//        trace("  + Parsing de la balise <button> +");
        if (this.xml.hasNode.button){
            this.parseButton(this.xml.node.button);
        }else{
            var defbtnxml = new Fast(Xml.parse('<button />').firstElement());
            this.parseButton(defbtnxml);
        }
//        trace("  + Parsing de la balise <font> +");
        if (this.xml.hasNode.font){
            this.parseFont(this.xml.node.font);
        }else{
            var deffontxml = new Fast(Xml.parse('<font/>').firstElement());
            this.parseFont(deffontxml);
        }
    }
    private function parseBackground(_xml:Fast){
        // parse le <background>
        this.bgColor = (_xml.has.color)? Std.parseInt(_xml.att.color):0xfff000;
        this.padding = (_xml.has.padding)? Std.parseInt(_xml.att.padding):1;
    }
    private function parseButton(_xml:Fast){
        // parse la balise <button>
        this.btnBgColor = (_xml.has.bgColor)? Std.parseInt(_xml.att.bgColor) : 0xfffeee;
        this.startColor = (_xml.has.startColor)? Std.parseInt(_xml.att.startColor) : 0xffec00;
        this.stopColor = (_xml.has.stopColor)? Std.parseInt(_xml.att.stopColor):0xffaa05;
        this.overColor = (_xml.has.overColor)? Std.parseInt(_xml.att.overColor):0xff6f05;
        this.alpha = (_xml.has.alpha)? Std.parseFloat(_xml.att.alpha):1.0;
        this.init_btn.w = (_xml.has.width)? Std.parseInt(_xml.att.width): 150;
        this.init_btn.h = (_xml.has.height)? Std.parseInt(_xml.att.height): 50;
        this.init_btn.x = 0;
        this.init_btn.y = 0;
        this.init();
    }
    private function parseFont(_xml:Fast){
        // parse la balise font <font>
        this.font = new PoshTextFormat();
        this.font.size = (_xml.has.size)? Std.parseInt(_xml.att.size): 13;
        this.font.font = (_xml.has.font)? xml.att.font:"Symbols";
        this.font.color = (_xml.has.color)? Std.parseInt(_xml.att.color): 0x000000;
        this.font.left = (_xml.has.left)? Std.parseInt(_xml.att.left) : 60;
        this.font.top = (_xml.has.top)? Std.parseInt(_xml.att.top) : 5;
    }
    public function pad(p:Int, ?btnBgColor:Int=0xffffff){
        // padd les elements de style du bouton (permet de faire des elements imbriques...)
        this.w -= 2*p;
        this.h -= 2*p;
        this.x += p;
        this.y += p;
        this.btnBgColor = btnBgColor;
    }
    public function init(){
        // Remet les infos de taille à la valeur maximale
        this.w = this.init_btn.w;
        this.h = this.init_btn.h;
        this.x = this.init_btn.x;
        this.y = this.init_btn.y;
    }
}
